//---------------------------------------------------------------------------

#include <vcl.h>
#include <iterator>
#include "algostuff.hpp"

#include <conio.h> //  getch()

#pragma hdrstop

//---------------------------------------------------------------------------

#pragma argsused
using namespace std;

std::string ToRus(const std::string &in)
{
  char *buff = new char [in.length()+1];
  CharToOem(in.c_str(),buff);
  std::string out(buff);
  delete [] buff;
  return out;
}

int main()
{
  deque<int> coll;

  INSERT_ELEMENTS(coll,3,7);
  INSERT_ELEMENTS(coll,2,6);
  INSERT_ELEMENTS(coll,1,5);
  PRINT_ELEMENTS(coll," :\n");

  //    
  nth_element (coll.begin(),     //  
               coll.begin()+3,   //  
               coll.end());      //  

  // 
  cout << ToRus("  :  ");
  copy (coll.begin(), coll.begin()+4,
        ostream_iterator<int>(cout," "));
  cout << endl;

  //    
  nth_element (coll.begin(),     //  
               coll.end()-4,     //  
               coll.end());      //  

  // 
  cout << ToRus("  :  ");
  copy (coll.end()-4, coll.end(),
        ostream_iterator<int>(cout," "));
  cout << endl;

  //     ( )
  nth_element (coll.begin(),     //  
               coll.begin()+3,   //  
               coll.end(),       //  
               greater<int>());  //  

  // 
  cout << ToRus("  :  ");
  copy (coll.begin(), coll.begin()+4,
        ostream_iterator<int>(cout," "));
  cout << endl;


  getch();
  return 0;
}

//---------------------------------------------------------------------------